#
# -*- awk -*-

# This file first checks that the change log is up to date
# if so, it builds the release change log
# and builds a version file for the other build tools to 
# use in naming the components.
#
# we assume fr (the main) is passed and therefor open.
BEGIN { 
version = ""
}

firstfile == "" {firstfile = FILENAME}

firstfile == FILENAME {
    while ( NR < 9 ) {
	ver = gensub(/.+<20([0-9][0-9])([0-9][0-9])([0-9][0-9]).([0-9][0-9]).+/, "\\1.\\2.\\3.\\4", "g")
	if ( ver != $0 ) {
	    gsub(/\.0/,".",ver)
	    version = ver
	    print "Current version is "version
	    break
	}
	getline
    }
    if (version == "") {
	print "Failed to find version in first 10 lines of "FILENAME".  Fix this"
	exit 1
    }
    nextfile
}
#/.*/ {print "processing "FILENAME " begining with line "FNR" first file was "firstfile}
firstfile != FILENAME {
    # Second file, now we need to find the revcode...
    r[FNR] = $0
    while ( FNR < 10 ) {
#	print "testing "$0
	if (match($0,/.*[0-9][0-9].[0-9][0-9]*.[0-9][0-9]*.*/)) {
	    ver2 = gensub(/.*([0-9][0-9].[0-9][0-9]*.[0-9][0-9]*.[0-9][0-9]*).*/, "\\1","g")
	    if ( ver2 != version) {
		print "Version mismatch, \n"firstfile" version "version",\n" FILENAME" version "ver2"\n fix this!"
		exit 1
	    }
	    print "Found version "ver2 " in "FILENAME" building change log"
	    for (i = 1; i <= FNR; i++) { print r[i] >"changelog-"ver2".txt" }
	    while (getline > 0) {
		print $0 >"changelog-"ver2".txt"
		if (match($0,/^--+.?$/) && length($0)>30) {
		    break
		}
	    }
	    print ver2 >"version"
	    print "./wrapwindows " ver2 | "/bin/sh"
	    print "./pack " ver2 | "/bin/sh"
	    print "success version "ver2 " made and ready"
	    print "Time to test."
	    exit 0
	    break
	}
	next
    }
    print "Failed to find version in first 10 lines of history ("FILENAME") file.  Fix this."
    exit 0
}

END {
}